package com.modcrafting.security;

import java.util.logging.Level;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

public class DragonCommand implements CommandExecutor {
	SecurityDragon plugin;
	public DragonCommand(SecurityDragon securityDragon) {
		this.plugin = securityDragon;
	}

	public boolean onCommand(CommandSender sender, Command command, String commandLabel, String[] args) {
    	YamlConfiguration config = (YamlConfiguration) plugin.getConfig();
		boolean auth = false;
		Player player = null;
		String admin = "server";
		if (sender instanceof Player){
			player = (Player)sender;
			 	if (player.isOp()) auth = true; 
			admin = player.getName();
		}else{
			auth = true; //if sender is not a player - Console
		}

		if (args.length < 1) return false;
	if(auth){
		if (args[0].equalsIgnoreCase("config")){
			if (args.length < 2){
				sender.sendMessage("/dragon config (join/open/ingamelogin) (true/false)");
				return true;
			}
			if (args[1].equalsIgnoreCase("join")){
				boolean pvar = args[2].equalsIgnoreCase("true");
				config.set("join" ,(boolean) pvar);
				plugin.join = pvar;
				return true;
			}
			if (args[1].equalsIgnoreCase("open")){
				boolean pvar = args[2].equalsIgnoreCase("true");
				config.set("openlogins" ,(boolean) pvar);
				plugin.openlogins = pvar;
				return true;
			}
			if (args[1].equalsIgnoreCase("ingamelogin")){
				boolean pvar = args[2].equalsIgnoreCase("true");
				config.set("ingamelogin" ,(boolean) pvar);
				plugin.ingamelogin = pvar;
				return true;
			}
			sender.sendMessage("/dragon config (login/open) (true/false)");
		}
		if (args[0].equalsIgnoreCase("help")){
			sender.sendMessage(ChatColor.RED + "SecurityDragon");
			sender.sendMessage(ChatColor.DARK_RED + "----------------");
			sender.sendMessage(ChatColor.YELLOW + "/dragon");
			if(plugin.ingamelogin){
			sender.sendMessage(ChatColor.GOLD + "          login (password)");
			sender.sendMessage(ChatColor.YELLOW + "          -logs in /if already loggedin resets pass");
			}
			sender.sendMessage(ChatColor.GOLD + "          config (join/open/ingamelogin) (true/false)");
			sender.sendMessage(ChatColor.YELLOW + "          -Sets login ability");
			sender.sendMessage(ChatColor.GOLD + "          remove (player)");
			sender.sendMessage(ChatColor.YELLOW + "          -Removes registration");
			sender.sendMessage(ChatColor.GOLD + "          status");
			sender.sendMessage(ChatColor.YELLOW + "          -Displays current status");
			sender.sendMessage(ChatColor.GOLD + "          help");
			sender.sendMessage(ChatColor.YELLOW + "          -Displays this help");;
			sender.sendMessage(ChatColor.GOLD + "          reload");
			sender.sendMessage(ChatColor.YELLOW + "          -reload this plugin");
			sender.sendMessage(ChatColor.DARK_RED + "----------------");
		}
		if (args[0].equalsIgnoreCase("remove")){
			if (args.length < 2){
				sender.sendMessage("/dragon remove (player)");
				return true;
			}
			String p = expandName(args[1]);
			Player addPlayer = plugin.getServer().getPlayer(p);
			plugin.allowedPlayers.remove(p.toLowerCase());
			plugin.db.removeFromlist(p.toLowerCase());
			//custom message admin
			String adminMsg = config.getString("messages.removeAdminMsg", "You've removed their registration!");
			adminMsg = adminMsg.replaceAll("%player%", p);
			sender.sendMessage(ChatColor.GOLD + adminMsg);
			//custom message player
			String adminMsgPlayer = config.getString("messages.removePlayerMsg", "You registration has been removed!");
			adminMsgPlayer = adminMsgPlayer.replaceAll("%admin%", admin);
			addPlayer.kickPlayer(ChatColor.GOLD + adminMsgPlayer);
		}
		if(args[0].equalsIgnoreCase("status")){
			String str = null;
			if (plugin.openlogins) str = "Server is completely open.";
			if (plugin.join) str = "All players can join, Registered users full access.";
			if (plugin.ingamelogin) str = "All players can join, Verifed Login full access.";
			sender.sendMessage(ChatColor.GOLD + str);
			return true;
		}
		if(args[0].equalsIgnoreCase("reload")){
			plugin.allowedPlayers.clear();
			plugin.loggedPlayers.clear();
			SecurityDragon.log.log(Level.INFO, "[SecurityDragon] Disabling Plugin.");
			plugin.getServer().getPluginManager().disablePlugin(plugin);
			SecurityDragon.log.log(Level.SEVERE, "[SecurityDragon] Attempting Restart.");
			plugin.getServer().getPluginManager().enablePlugin(plugin);
			SecurityDragon.log.log(Level.INFO, "[SecurityDragon] " + admin + " reloaded the plugin.");
			return true;
		}
	}
		if(args[0].equalsIgnoreCase("login")){
			if (args.length < 2){
				sender.sendMessage("/dragon login (password)");
				return true;
			}
			String p = sender.getName();
			String verifiedName = plugin.db.login(p.toLowerCase(),args[1]);
			if(verifiedName != null){
				sender.sendMessage(ChatColor.GREEN + "Login Successful!");
				plugin.loggedPlayers.add(verifiedName);
			}else{
				if(plugin.loggedPlayers.contains(p.toLowerCase())) sender.sendMessage(ChatColor.GREEN + "Already Logged In!");
				sender.sendMessage(ChatColor.RED + "Login Failed!");
			}
			return true;
		}
	
			
		return false;
	}
	public String expandName(String p) {
		int m = 0;
		String Result = "";
		for (int n = 0; n < plugin.getServer().getOnlinePlayers().length; n++) {
			String str = plugin.getServer().getOnlinePlayers()[n].getName();
			if (str.matches("(?i).*" + p + ".*")) {
				m++;
				Result = str;
				if(m==2) {
					return null;
				}
			}
			if (str.equalsIgnoreCase(p))
				return str;
		}
		if (m == 1)
			return Result;
		if (m > 1) {
			return null;
		}
		if (m < 1) {
			return p;
		}
		return p;
	}
}
