package com.modcrafting.security;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashSet;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.event.Event;
import org.bukkit.event.Event.Priority;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class SecurityDragon extends JavaPlugin{
	public boolean join;
	public boolean openlogins;
	public boolean ingamelogin;
	public final static Logger log = Logger.getLogger("Minecraft");
	public HashSet<String> allowedPlayers = new HashSet<String>();
	public HashSet<String> loggedPlayers = new HashSet<String>();
	public SQLDatabases db = new SQLDatabases();
	public String maindir = "plugins/SecurityDragon/";
	private final SecurityDragonPlayerListener playerListener = new SecurityDragonPlayerListener(this);
	private final SecurityDragonBlockListener blockListener = new SecurityDragonBlockListener(this);

	public void onDisable() {
		allowedPlayers.clear();
		System.out.println("SecurityDragon disabled.");
	}

	protected void createDefaultConfiguration(String name) {
		File actual = new File(getDataFolder(), name);
		if (!actual.exists()) {

			InputStream input =
				this.getClass().getResourceAsStream("/" + name);
			if (input != null) {
				FileOutputStream output = null;

				try {
					output = new FileOutputStream(actual);
					byte[] buf = new byte[8192];
					int length = 0;
					while ((length = input.read(buf)) > 0) {
						output.write(buf, 0, length);
					}

					System.out.println(getDescription().getName()
							+ ": Default configuration file written: " + name);
				} catch (IOException e) {
					e.printStackTrace();
				} finally {
					try {
						if (input != null)
							input.close();
					} catch (IOException e) {}

					try {
						if (output != null)
							output.close();
					} catch (IOException e) {}
				}
			}
		}
	}
	public void onEnable() {
		YamlConfiguration Config = (YamlConfiguration) getConfig();
		PluginDescriptionFile pdfFile = this.getDescription();
		new File(maindir).mkdir();
		createDefaultConfiguration("config.yml"); //Swap for new setup
		loadCommands();
		if (Config != null) log.log(Level.INFO, "[" + pdfFile.getName() + "]" + " Configuration: config.yml Loaded!");
		log.log(Level.INFO, "[" + pdfFile.getName() + "]" + " version " + pdfFile.getVersion() + " is enabled!");
		PluginManager pm = getServer().getPluginManager();
		pm.registerEvent(Event.Type.PLAYER_LOGIN, playerListener, Priority.Highest, this);
		pm.registerEvent(Event.Type.PLAYER_JOIN, playerListener, Priority.Monitor, this);
		pm.registerEvent(Event.Type.PLAYER_COMMAND_PREPROCESS, playerListener, Priority.High, this);
		pm.registerEvent(Event.Type.PLAYER_CHAT, playerListener, Priority.Normal, this);
		pm.registerEvent(Event.Type.BLOCK_PLACE, blockListener, Priority.Normal, this);
		pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Priority.Normal, this);
		db.initialize(this);
		join = Config.getBoolean("join" , true);
		//Can Join
		openlogins = Config.getBoolean("openlogins" , false);
		//Completely Open
		ingamelogin = Config.getBoolean("ingamelogin" , true);
		//Can login ingame while join true / disables registrant full access
	}

	private void loadCommands() {
		getCommand("dragon").setExecutor(new DragonCommand(this));
		
	}
	

}
