package com.modcrafting.security;

import org.bukkit.ChatColor;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerLoginEvent;

public class SecurityDragonPlayerListener extends PlayerListener{
	SecurityDragon plugin;
	public SecurityDragonPlayerListener(SecurityDragon securityDragon) {
		this.plugin = securityDragon;
	}
	public void onPlayerLogin(PlayerLoginEvent event){
		if(plugin.openlogins) return;
		if(plugin.join) return;
		Player player = event.getPlayer();
		
		String pl = plugin.db.getName(player.getName());
		if(pl != null) plugin.allowedPlayers.add(pl);
		
		if(!plugin.allowedPlayers.contains(player.getName().toLowerCase())){
			YamlConfiguration config = (YamlConfiguration) plugin.getConfig();
			String adminMsg = config.getString("messages.Login", "You must register!");
			event.disallow(PlayerLoginEvent.Result.KICK_OTHER, adminMsg);
			return;
		}
		
	}
	public void onPlayerJoin(PlayerJoinEvent event){
		if(plugin.openlogins) return;
		if(plugin.join) return;
		Player player = event.getPlayer();
		
		String pl = plugin.db.getName(player.getName());
		if(pl != null) plugin.allowedPlayers.add(pl);
		
		if(!plugin.allowedPlayers.contains(player.getName().toLowerCase())){
			YamlConfiguration config = (YamlConfiguration) plugin.getConfig();
			event.setJoinMessage(null);
			String adminMsg = config.getString("messages.Login", "You must register!");
			player.kickPlayer(adminMsg);
			return;
		}
		
	}
	public void onPlayerCommandPreprocess(PlayerCommandPreprocessEvent event){
		YamlConfiguration config = (YamlConfiguration) plugin.getConfig();
		if(plugin.openlogins) return;
		Player player = event.getPlayer();
		if(plugin.ingamelogin){	
			if(plugin.loggedPlayers.contains(player.getName().toLowerCase())){
				return;
			}else{
				String adminMsg = config.getString("messages.Disabledcommand", "You must register!");
				player.sendMessage(ChatColor.GRAY + adminMsg);
				//event.setCancelled(true);
			}
		}
		if(!plugin.allowedPlayers.contains(player.getName().toLowerCase())){
			String adminMsg = config.getString("messages.Disabledcommand", "You must register!");
			player.sendMessage(ChatColor.GRAY + adminMsg);
			//event.setCancelled(true);
		}
	}
	public void onPlayerChat(PlayerChatEvent event){
		YamlConfiguration config = (YamlConfiguration) plugin.getConfig();
		if(plugin.openlogins) return;
		Player player = event.getPlayer();
		
		if(plugin.ingamelogin){	
			if(plugin.loggedPlayers.contains(player.getName().toLowerCase())){
				return;
			}else{
				String adminMsg = config.getString("messages.Disabledchat", "You must register!");
				player.sendMessage(ChatColor.GRAY + adminMsg);
				event.setCancelled(true);
			}
		}
		
		if(!plugin.allowedPlayers.contains(player.getName().toLowerCase())){
			String adminMsg = config.getString("messages.Disabledchat", "You must register!");
			player.sendMessage(ChatColor.GRAY + adminMsg);
		 	event.setCancelled(true);
		}
	}
}
